// 
// File:          TAO_Solver_Impl.hh
// Symbol:        TAO.Solver-v0.3
// Symbol Type:   class
// Babel Version: 0.10.2
// Description:   Server-side implementation for TAO.Solver
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.10.2
// 

#ifndef included_TAO_Solver_Impl_hh
#define included_TAO_Solver_Impl_hh

#ifndef included_sidl_cxx_hh
#include "sidl_cxx.hh"
#endif
#ifndef included_TAO_Solver_IOR_h
#include "TAO_Solver_IOR.h"
#endif
// 
// Includes for all method dependencies.
// 
#ifndef included_LinearAlgebra_Factory_hh
#include "LinearAlgebra_Factory.hh"
#endif
#ifndef included_Optimize_OptimizationModel_hh
#include "Optimize_OptimizationModel.hh"
#endif
#ifndef included_Solver_TerminateReason_hh
#include "Solver_TerminateReason.hh"
#endif
#ifndef included_TAO_Solver_hh
#include "TAO_Solver.hh"
#endif
#ifndef included_sidl_BaseInterface_hh
#include "sidl_BaseInterface.hh"
#endif
#ifndef included_sidl_ClassInfo_hh
#include "sidl_ClassInfo.hh"
#endif


// DO-NOT-DELETE splicer.begin(TAO.Solver._includes)
#include "tao.h"
#include "LinearAlgebra_Factory.hh"
// DO-NOT-DELETE splicer.end(TAO.Solver._includes)

namespace TAO { 

  /**
   * Symbol "TAO.Solver" (version 0.3)
   */
  class Solver_impl
  // DO-NOT-DELETE splicer.begin(TAO.Solver._inherits)
  // Put additional inheritance here...
  // DO-NOT-DELETE splicer.end(TAO.Solver._inherits)
  {

  private:
    // Pointer back to IOR.
    // Use this to dispatch back through IOR vtable.
    Solver self;

    // DO-NOT-DELETE splicer.begin(TAO.Solver._implementation)
    TAO_SOLVER tao;
    LinearAlgebra::Factory lafactory;
    double diag; // Diagonal element for lmvm init hessian
    // DO-NOT-DELETE splicer.end(TAO.Solver._implementation)

  private:
    // private default constructor (required)
    Solver_impl() 
    {} 

  public:
    // sidl constructor (required)
    // Note: alternate Skel constructor doesn't call addref()
    // (fixes bug #275)
    Solver_impl( struct TAO_Solver__object * s ) : self(s,true) { _ctor(); }

    // user defined construction
    void _ctor();

    // virtual destructor (required)
    virtual ~Solver_impl() { _dtor(); }

    // user defined destruction
    void _dtor();

    // static class initializer
    static void _load();

  public:

    /**
     * user defined non-static method.
     */
    int32_t
    Create (
      /* in */ const ::std::string& method
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    Destroy() throw () 
    ;
    /**
     * user defined non-static method.
     */
    int32_t
    SetTolerances (
      /* in */ double fatol,
      /* in */ double frtol,
      /* in */ double catol,
      /* in */ double crtol
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SolveApplication (
      /* in */ ::Optimize::OptimizationModel app
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    View() throw () 
    ;
    /**
     * user defined non-static method.
     */
    int32_t
    GetIterationData (
      /* out */ int32_t& iterate,
      /* out */ double& f,
      /* out */ double& gnorm,
      /* out */ double& cnorm,
      /* out */ double& xdiff,
      /* out */ ::Solver::TerminateReason& reason
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    GetMethod (
      /* out */ ::std::string& type
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetFunctionLowerBound (
      /* in */ double fmin
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    GetGradientTolerances (
      /* out */ double& gatol,
      /* out */ double& grtol,
      /* out */ double& gttol
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetGradientTolerances (
      /* in */ double gatol,
      /* in */ double grtol,
      /* in */ double gttol
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetMaximumFunctionEvaluations (
      /* in */ int32_t nfcn
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetMaximumIterates (
      /* in */ int32_t maxits
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetMethod (
      /* in */ const ::std::string& type
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetLAFactory (
      /* in */ ::LinearAlgebra::Factory factory
    )
    throw () 
    ;

    /**
     * user defined non-static method.
     */
    int32_t
    SetFromOptions() throw () 
    ;
    /**
     * user defined non-static method.
     */
    int32_t
    GetSolverHandle (
      /* out */ void*& handle
    )
    throw () 
    ;

  };  // end class Solver_impl

} // end namespace TAO

// DO-NOT-DELETE splicer.begin(TAO.Solver._misc)
// Put miscellaneous things here...
// DO-NOT-DELETE splicer.end(TAO.Solver._misc)

#endif
