/*$Id: nls.h 1.25 02/09/16 23:00:56-05:00 benson@rockies.mcs.anl.gov $*/

/*
    Context for a Newton line search method (unconstrained minimization)
 */

#ifndef __TAO_NLS_H
#define __TAO_NLS_H
#include "tao_solver.h"

typedef struct {
  TaoVec *RHS;
  TaoVec *W;
  TaoVec *S;
  TaoVec *G;
  double gamma;		     /* damping parameter */
  double gamma_factor;	     /* damping parameter */
  int    max_kspiter_factor; /* computes max KSP iterations */

} TAO_NLS;

EXTERN_C_BEGIN
int TaoLineSearchGetDampingParameter_NLS(TAO_SOLVER,double *);
EXTERN_C_END

#endif
